import { CommandHandler } from '@nestjs/cqrs';
import { AuthRepository } from '../../adapters/secondaries/auth.repository';
import { UsernameRepository } from '../../adapters/secondaries/username.repository';
import { DeleteAuthCommand } from '../../commands/delete-auth.command';

@CommandHandler(DeleteAuthCommand)
export class DeleteAuthUseCase {
  constructor(
    private readonly _authRepository: AuthRepository,
    private readonly _usernameRepository: UsernameRepository,
  ) {}

  async execute(command: DeleteAuthCommand) {
    try {
      const usernames = await this._usernameRepository.findAll(1, 99, {
        uuid: command.deleteAuthRequest.uuid,
      });
      usernames.data.map(
        async (username) =>
          await this._usernameRepository.delete({
            username: username.username,
          }),
      );
      return await this._authRepository.delete({
        uuid: command.deleteAuthRequest.uuid,
      });
    } catch (e) {
      throw e;
    }
  }
}
